﻿using EPiServer.Commerce.Order;
using EPiServer.ServiceLocation;
using Mediachase.Commerce.Orders;
using Mediachase.Commerce.WorkflowCompatibility;

namespace Mediachase.Commerce.Workflow.Activities.ReturnForm
{
    public class CalculateExchangeOrderStatusActivity : ReturnFormBaseActivity
    {
        private Injected<IOrderRepository> OrderRepository;
        private Injected<IPurchaseOrderProcessor> OrderProcessor;

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            if (ReturnFormStatus == ReturnFormStatus.Complete)
            {
                var exchangeOrder = ReturnOrderForm.ExchangeOrderGroupId.HasValue ? OrderRepository.Service.Load<IPurchaseOrder>(ReturnOrderForm.ExchangeOrderGroupId.Value) : null;
                // Need change ExchangeOrder from AwaitingCompletition to InProgress.
                if (exchangeOrder?.OrderStatus == OrderStatus.AwaitingExchange)
                {
                    OrderProcessor.Service.ProcessOrder(exchangeOrder);
                    OrderRepository.Service.Save(exchangeOrder);
                }
            }

            // Return the closed status indicating that this activity is complete.
            return ActivityExecutionStatus.Closed;
        }
    }
}